/*
 *  TalKT
 *  Copyright (C) 1999 Jochen Sarrazin, DG6VJ. All rights reserved.
 *  
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#ifndef AX25K_H
#define AX25K_H


#include <qtimer.h>
#include <qsocketnotifier.h>



class AX25 : public QObject
{
   Q_OBJECT;
public:
   AX25();
   ~AX25();

   void connectIt( char *call, char *path, char *port, char *mycall );
   void connectionGot( int _fd );
   void disc();

   int fd;

public slots:
   void poll();
   void rxFrame(int socket);

private:
   int makeConnect( char *call, char *digis, char *port, int *error, char *mycall );

   QTimer *timer;
   QSocketNotifier *sockrx;
};


class ListenAX25 : public QObject
{
   Q_OBJECT;
public:
   ListenAX25( const char *_call, char *_port );
   ~ListenAX25();

public slots:
   void rxFrame(int socket);

private:
   int fd;
   char mycall[20];
   char port[20];

   QSocketNotifier *sockrx;
};



#endif

