/*
 *  TalKT
 *  Copyright (C) 1999 Jochen Sarrazin, DG6VJ. All rights reserved.
 *  
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#include "dialog.h"
#include "dialog.moc"

#include <qlabel.h>

#include <kapp.h>


#define BUTTON_WIDTH 80
#define BUTTON_HEIGHT 25


DlgConnect::DlgConnect() : QDialog(0, "", true)
{
   setFixedSize( 280, 180 );

   setCaption(klocale->translate("TalKT: Make connect"));


   QLabel *l = new QLabel( this );
   l->setGeometry( 10, 20, 50, 20 );
   l->setText("Call");

   call = new QLineEdit( this );
   call->setGeometry( 10, 40, 80, 20 );


   l = new QLabel( this );
   l->setGeometry( 100, 20, 50, 20 );
   l->setText("Path");

   path = new QLineEdit( this );
   path->setGeometry( 100, 40, 150, 20 );


   l = new QLabel( this );
   l->setGeometry( 10, 70, 50, 20 );
   l->setText("Port");

   port = new QLineEdit( this );
   port->setGeometry( 10, 90, 80, 20 );


   l = new QLabel( this );
   l->setGeometry( 100, 70, 50, 20 );
   l->setText("Mycall");

   mycall = new QLineEdit( this );
   mycall->setGeometry( 100, 90, 80, 20 );

   ret = new QAccel( this );
   ret->connectItem( ret->insertItem( Key_Return ), this, SLOT(accept()) );


   int abstand = (width()-(2*BUTTON_WIDTH))/3;
   ok = new QPushButton( this );
   ok->setText( klocale->translate ("&Ok") );
   ok->setGeometry(abstand, height()-30, BUTTON_WIDTH, BUTTON_HEIGHT);
   connect(ok, SIGNAL(clicked()), this, SLOT(accept()));

   abort = new QPushButton( this );
   abort->setText( klocale->translate ("&Abort") );
   abort->setGeometry(abstand*2+BUTTON_WIDTH, height()-30, BUTTON_WIDTH, BUTTON_HEIGHT);
   connect(abort, SIGNAL(clicked()), this, SLOT(reject()));

   call->setFocus();
}


DlgConnect::~DlgConnect()
{
   delete ok;
   delete abort;
   delete call;
   delete path;
   delete port;
   delete mycall;
}


void DlgConnect::getData( char *_call, char *_path, char *_port, char *_mycall )
{
   strcpy(_call, call->text());
   strcpy(_path, path->text());
   strcpy(_port, port->text());
   strcpy(_mycall, mycall->text());
}


void DlgConnect::setData(  char *_call,  char *_path, char *_port, char *_mycall )
{
  call->insert(_call);
  path->insert(_path);
  port->insert(_port);
  mycall->insert(_mycall);
}


DlgPrefs::DlgPrefs() : QDialog(0, "", true)
{
   setFixedSize( 280, 180 );

   setCaption(klocale->translate("TalKT: Preferences"));


   QLabel *l = new QLabel( this );
   l->setGeometry( 10, 20, 50, 20 );
   l->setText("MyCall");

   mycall = new QLineEdit( this );
   mycall->setGeometry( 10, 40, 80, 20 );


   l = new QLabel( this );
   l->setGeometry( 100, 20, 50, 20 );
   l->setText("Port");

   port = new QLineEdit( this );
   port->setGeometry( 100, 40, 50, 20 );

   l = new QLabel( this );
   l->setGeometry( 10, 70, 90, 20 );
   l->setText("Description");

   description = new QLineEdit( this );
   description->setGeometry( 10, 90, 200, 20 );

   /*
   l = new QLabel( this );
   l->setGeometry( 100, 70, 50, 20 );
   l->setText("Mycall");

   mycall = new QLineEdit( this );
   mycall->setGeometry( 100, 90, 80, 20 );
   */


   int abstand = (width()-(2*BUTTON_WIDTH))/3;
   ok = new QPushButton( this );
   ok->setText( klocale->translate ("&Ok") );
   ok->setGeometry(abstand, height()-30, BUTTON_WIDTH, BUTTON_HEIGHT);
   connect(ok, SIGNAL(clicked()), this, SLOT(accept()));

   abort = new QPushButton( this );
   abort->setText( klocale->translate ("&Abort") );
   abort->setGeometry(abstand*2+BUTTON_WIDTH, height()-30, BUTTON_WIDTH, BUTTON_HEIGHT);
   connect(abort, SIGNAL(clicked()), this, SLOT(reject()));
}


DlgPrefs::~DlgPrefs()
{
   delete ok;
   delete abort;
   //   delete call;
   delete description;
   delete port;
   delete mycall;
}


void DlgPrefs::getData( char *_mycall, char *_port, char *_description )
{
  //  strcpy(_call, call->text());
   strcpy(_description, description->text());
   strcpy(_port, port->text());
   strcpy(_mycall, mycall->text());
}
void DlgPrefs::setData( char *_mycall, char *_port, char *_description )
{
  //  strcpy(_call, call->text());
  //  strcpy(_path, path->text());
   port->insert(_port);
   mycall->insert(_mycall);
   description->insert(_description);
}



