/*
 *  TalKT
 *  Copyright (C) 1999 Jochen Sarrazin, DG6VJ. All rights reserved.
 *            (C) 1999 Hans-Peter Zorn, DG4IAD.
 *  
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#include "main.h"
#include "global.h"
#include "toolbox.h"
#include "dialog.h"

#include <stdlib.h>
#include <stdio.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>

#include <kmsgbox.h>
#include <kiconloader.h>

#include <qkeycode.h>
#include <qaccel.h>
#include <qsplitter.h>
#include <time.h>

#define BUTTON_WIDTH 80
#define BUTTON_HEIGHT 25


QColor colors[17] = {black,white,darkGray,gray,lightGray,red,green,
                     blue,cyan,magenta,yellow,darkRed,darkGreen,darkBlue,
                     darkCyan,darkMagenta,darkYellow};

bool beenden=false;


KApplication *mykapp;
TopLevel *toplevel;
// Aus global.h
s_config *config;





/*
 *  TopLevel::TopLevel( QWidget *parent=0, const char *name=0 )
 * Konstruktor des Hauptfensters
 */
TopLevel::TopLevel( const char *name )
             : KTopLevelWidget(name)
{
   KConfig *kconfig;
   setFixedSize( 250, 170 );

   setCaption(klocale->translate("TalKT"));


//   setupMenuBar();
//   setupToolBar();
   setupStatusBar();



   QLabel *l = new QLabel( this );
   l->setGeometry( 10, 20, 50, 20 );
   l->setText("Call:");

   l = new QLabel( this );
   l->setGeometry( 10, 50, 50, 20 );
   l->setText("Name:");

   lcall = new QLabel( this );
   lcall->setGeometry( 60, 20, 80, 20 );
   lcall->setFrameStyle( QFrame::Panel | QFrame::Sunken );

   lname = new QLabel( this );
   lname->setGeometry( 60, 50, 150, 20 );
   lname->setFrameStyle( QFrame::Panel | QFrame::Sunken );


   int abstand = (width()-(3*BUTTON_WIDTH))/4;
   btnconnect = new QPushButton( this );
   btnconnect->setText( klocale->translate ("&Connect") );
   btnconnect->setGeometry(abstand, height()-30-statusbar->height(), BUTTON_WIDTH, BUTTON_HEIGHT);
   connect(btnconnect, SIGNAL(clicked()), this, SLOT(slotConnect()));

   btnptt = new QPushButton( this );
   btnptt->setText( klocale->translate ("&PTT") );
   btnptt->setGeometry(abstand*2+BUTTON_WIDTH, height()-30-statusbar->height(), BUTTON_WIDTH, BUTTON_HEIGHT);
   btnptt->setEnabled( false );
   connect(btnptt, SIGNAL(clicked()), this, SLOT(slotPTT()));
   btnprefs = new QPushButton( this );
   btnprefs->setText( klocale->translate ("&Prefs") );
   btnprefs->setGeometry(abstand*3+BUTTON_WIDTH*2, height()-30-statusbar->height(), BUTTON_WIDTH, BUTTON_HEIGHT);
   connect(btnprefs, SIGNAL(clicked()), this, SLOT(slotPrefs()));


//   setView(output);

   savestr = NULL;
   savestrlen = 0;
   old_status = 0;
   kconfig = mykapp->getConfig();
   kconfig->setGroup("main");
   if (config->mycall[0] == '\0')
      strcpy(config->mycall, "TALKT-0");
   if (config->myport[0] == '\0')
      strcpy(config->myport, "ax0");
  
   ax25 = new AX25();

   listenax25 = new ListenAX25( config->mycall, config->myport );
   connect(&melpproct,SIGNAL(processExited(KProcess *)),this,SLOT(slotProcExitMT(KProcess *)));
   connect(&soxproct,SIGNAL(processExited(KProcess *)),this,SLOT(slotProcExitST(KProcess *)));
   connect(&melpprocr,SIGNAL(processExited(KProcess *)),this,SLOT(slotProcExitMR(KProcess *)));
   connect(&soxprocr,SIGNAL(processExited(KProcess *)),this,SLOT(slotProcExitSR(KProcess *)));


   show();
}


TopLevel::~TopLevel()
{
}


void TopLevel::setupStatusBar()
{
   statusbar = new KStatusBar( this );

   statusbar->insertItem("WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW", ID_STATUS);

   statusbar->changeItem("", ID_STATUS);

   statusbar->setInsertOrder(KStatusBar::LeftToRight);
   statusbar->setBorderWidth(1);
   setStatusBar( statusbar );
}


void TopLevel::setStatusText( char *text )
{
   statusbar->changeItem( text, ID_STATUS );
}


void TopLevel::setupToolBar()
{
/*   toolbar = new KToolBar( this );

   KIconLoader *loader = mykapp->getIconLoader();

   QPixmap pixmap;

   pixmap = loader->loadIcon( "disconnected.xpm" );
   tb_conn = toolbar->insertButton( pixmap, 0,
                                    SIGNAL(clicked()), this,
                                    SLOT(slotConnect()), true, "make connect");


   toolbar->setBarPos( KToolBar::Top );

   addToolBar(toolbar);*/
}



/*
 *  void TopLevel::setupMenuBar()
 * Das Hauptmenue wird aufgebaut und an das KTopLevelWidget angedockt.
 */
void TopLevel::setupMenuBar()
{
/*   pref = new QPopupMenu();

   pref->insertItem( klocale->translate("&Colors"), this, SLOT(slotPrefColors()));
   pref->insertItem( klocale->translate("&DX-Cluster-Spy"), this, SLOT(slotPrefDX()));


   file = new QPopupMenu ();

   file->insertItem( klocale->translate("&Preferences"), pref );
   file->insertSeparator( -1 );
   file->insertItem( klocale->translate("E&xit"), this, SLOT(slotBeenden()), ALT+Key_X);


   help = new QPopupMenu ();
   help->insertItem( klocale->translate("&Index"), this, SLOT(slotHelp()));
   help->insertItem( klocale->translate("&About"), this, SLOT(slotAbout()));



   menubar = new KMenuBar (this);
   menubar->insertItem( klocale->translate("&File"), file );
   menubar->insertSeparator( -1 );
   menubar->insertItem( klocale->translate("&Help"), help );

   setMenu(menubar);*/
}


void TopLevel::closeEvent(QCloseEvent *e)
{
   if (KMsgBox::yesNo(NULL,
                      klocale->translate("Quit TalKT?"),
                      klocale->translate("Do you really want to quit TalKT?"),
                      0,
                      klocale->translate("&Yes"),
                      klocale->translate("&No")) != 1)
   {
      e->ignore();
      return;
   }

   e->accept();
}


void TopLevel::resizeEvent(QResizeEvent *e)
{
   KTopLevelWidget::resizeEvent(e);
}


void TopLevel::slotBeenden()
{
   close();
}


void TopLevel::makeAX25Connect( char *call, char *path, char *port, char *mycall )
{
   ax25->connectIt( call, path, port, mycall );
}


void TopLevel::sendString( char *str, int len )
{
   if (ax25->fd != -1)
      write( ax25->fd, str, len );
}


void TopLevel::sendString( int fd, char *str )
{
   write( fd, str, strlen(str) );

}


void TopLevel::sendString( char *str )
{
   sendString(str, strlen(str));
}


void TopLevel::setStatus( int axstate )
{
   char tmp[500];


   // Haben wir connected?
   if (((old_status == 1) && (axstate == 4)) ||
       ((old_status == 0) && (axstate == 4)))
   {

      btnconnect->setText( klocale->translate ("&Disconnect") );
      disconnect(btnconnect, SIGNAL(clicked()), this, SLOT(slotConnect()));
      connect(btnconnect, SIGNAL(clicked()), this, SLOT(slotDisconnect()));

      // Hier werden die Befehle eingetragen, die bei einem gerade
      // aufgebauten Connect abgearbeitet werden sollen
      setStatusText( "Connected" );
      btnptt->setEnabled(true);

      sendString( "VoAX/0.1\r" );
      sendString( "UserAgent : TalKT\r");
      sprintf(tmp,"Callsign: %s\r",config->mycall);
      sendString(tmp);
      sendString( "Accept: audio/melp \r");
      sprintf(tmp,"User-Info: %s\r",config->description);
      sendString( tmp);
      sendString( "\r");
      //      VoAXState=VST_INIT_SENT;
      size=0;
   }

   // Verbindungsabbau
   if ((old_status > 1) && (axstate == 0))
   {
     setStatusText("Waiting for call");
     ax25->disc();
     old_status = 0;

     if (VoAXState==VST_REC_DATA) {
  	fclose(rxfile);
	remove(rxinfilename);
      }
      VoAXState=VST_INIT_SENT;

   }
   old_status = axstate;
}


void TopLevel::workWithFrame( char *rxstr, int rxstrlen )
{
   int i, len, hilfslen;
   char str[50000], str2[50000],tmp[200];


   // Diese Funktion wird mit allen Daten aufgerufen, die empfangen
   // werden.


   len = 0;
   if (savestr != NULL)
   {
      memcpy(str, savestr, savestrlen);
      len = savestrlen;
      free(savestr);
      savestr = NULL;
      savestrlen = 0;
   }
   hilfslen=-len;
   if (rxstrlen<0) return;
   memcpy(str+len, rxstr, rxstrlen);
   len += rxstrlen;
   str[len] = '\0';

   if (VoAXState!=VST_REC_DATA)
     while (str[0] != '\0')
       {
	 if ((i = POS('\r', str)) == -1)
	   {
	     // Kein Return - abspeichern
	     savestr = (char *) malloc(len);
	     memcpy(savestr, str, len);
	     savestrlen = len;
	     return;
	   }
	 else
	   {
	     memcpy( str2, str, i );
	     str2[i] = '\0';
	     len -= (i+1);
	     memmove( str, str+i+1, len );
	     str[len] = '\0';
	   }
	 
	 // Hier stehen die empfangenen Texte zeilenweise in str2. (Sowas
	 // wie ein Linemode also)
	 if (VoAXState!=VST_REC_DATA)
	   ++hilfslen +=strlen(str2);
	 switch(VoAXState) {
	 case VST_INIT_SENT:
	   if (!strcmp(str2,"VoAX/0.1")){
	     VoAXState=VST_REC_HEADER;
	     setStatusText("Header Received.");
	   }
	   break;
	 case VST_REC_HEADER:
	   //hier werden username etc ausgewertet...
	   if (!strncmp(str2,"Content-Type: ",14)) {
	     //strncpy(; //wenns mal verschiedene codecs geben sollte, wird hier ausgewaehlt
	   }
	   if (!strncmp(str2,"Callsign: ",10))
	     lcall->setText(&str2[10]);
	   if (!strncmp(str2,"User-Info: ",11))
	     lname->setText(&str2[11]);
	   if (!strncmp(str2,"Size: ",6)) {
	     size=atoi(&str2[6]);
	     sprintf(tmp,"Size: %i",size);
	     setStatusText(tmp);
	   }
	   if (str2[0]=='\0') { 
	     if (size>0) { 
	       sprintf(rxinfilename,"/tmp/%lx.%i",time(NULL),getpid());
	       if ((rxfile = fopen(rxinfilename,"w"))<0) {
		 printf("urks, file geht nich auf\n");
		 setStatusText("I/O Error");
	       }
	       VoAXState=VST_REC_DATA;
	       setStatusText("Waiting for data...");
	     }
	     else VoAXState=VST_REC_HEADER;
	   }
	   break;
	 case VST_REC_DATA:
	   // Daten...
	   break;
	 }
	    
   }

   if (VoAXState==VST_REC_DATA){
     rxbytes += rxstrlen-hilfslen;
     if (rxbytes>size)
       rxstrlen -= rxbytes-size;
     if (fwrite( &rxstr[hilfslen], 1, rxstrlen-hilfslen,rxfile)<0) {
       perror("fwrite rxfile");
     } 

     sprintf(tmp,"Received Data, %i/%i Bytes",rxbytes,size);
     setStatusText(tmp);
     if (rxbytes >= size) {
       fclose(rxfile);
       //       melpproc = new KProcess();
       melpprocr.clearArguments();
       sprintf(rxoutfilename,"/tmp/a%lx.%i",time(NULL),getpid());

       melpprocr << "/usr/bin/melp" << "-s" << "-i" << rxinfilename << "-o" << rxoutfilename;
       setStatusText("decoding...");
       melpprocr.start();
       VoAXState=VST_REC_HEADER;
       size=0;
       rxbytes=0;
     }
   

   }
}

void TopLevel::slotDisconnect()
{

   if (KMsgBox::yesNo(NULL,
                      klocale->translate("Close connection?"),
                      klocale->translate("Do you really want to close the current connection?"),
                      0,
                      klocale->translate("&Yes"),
                      klocale->translate("&No")) == 1)
   {
      // Die AX.25-Verbindung killen
      ax25->disc();
      old_status = 0;

      disconnect(btnconnect, SIGNAL(clicked()), this, SLOT(slotDisconnect()));
      connect(btnconnect, SIGNAL(clicked()), this, SLOT(slotConnect()));
      btnconnect->setText( klocale->translate ("&Connect") );
      btnptt->setEnabled( false );
      setStatusText("Disconnected...");

      // Mach' was beim Disconnecten
      return;
   }
}


void TopLevel::slotConnect()
{
   char call[20], path[100], port[20], tmp[100], mycall[20];
   DlgConnect *dlg = new DlgConnect();

   QPoint point = this->mapToGlobal (QPoint (0,0));

   QRect pos = this->geometry();
   dlg->setGeometry(point.x() + pos.width()/2  - dlg->width()/2,
 		   point.y() + pos.height()/2 - dlg->height()/2,
 		   dlg->width(),dlg->height());
   dlg->setData("","",config->myport,config->mycall);

   if (dlg->exec() == 1)
   {
      dlg->getData( call, path, port, mycall );
      makeAX25Connect( call, path, port, mycall );
      sprintf( tmp, "Making connect to %s...", call );
      setStatusText( tmp );
   }
   delete dlg;
   VoAXState=VST_INIT_SENT;
}

void TopLevel::slotPrefs()
{
  KConfig *kconfig;
  kconfig=mykapp->getConfig();

   DlgPrefs *dlg = new DlgPrefs();

   QPoint point = this->mapToGlobal (QPoint (0,0));

   QRect pos = this->geometry();
   dlg->setGeometry(point.x() + pos.width()/2  - dlg->width()/2,
 		   point.y() + pos.height()/2 - dlg->height()/2,
 		   dlg->width(),dlg->height());
   dlg->setData(config->mycall,config->myport,config->description);
   if (dlg->exec() == 1)
   {
      dlg->getData( config->mycall, config->myport, config->description );
      kconfig->setGroup("main");
      kconfig->writeEntry("mycall",config->mycall);
      kconfig->writeEntry("port",config->myport);
      kconfig->writeEntry("description",config->description);
      kconfig->sync();
      delete listenax25;
      listenax25 = new ListenAX25( config->mycall, config->myport );

   }
   delete dlg;

}


void TopLevel::slotPTT()
{

  //  KProcess soxproc, melpproc;
  //soxproc = new KProcess();
  // melpproc = new KProcess();
  if (soxproct.isRunning()) {
    soxproct.kill(SIGINT);
  } else {
    btnptt->setText(klocale->translate("PTT release"));
    setStatusText("recording...");
    if (melpproct.isRunning()) return;
    soxproct.clearArguments();
    sprintf(txinfilename,"/tmp/b%lx.%i",time(NULL),getpid());
    soxproct << "/usr/bin/sox" << "-r" << "8000" << "-s" << "-w" << "-t" << "ossdsp" << "/dev/dsp" <<"-t" << "raw" << txinfilename;
    soxproct.start();
  }
}

void TopLevel::slotProcExitST(KProcess *p) {
    // TX-Soxprozess wurde beendet, jetzt wird der coder aufgerufen.
    melpproct.clearArguments();
    sprintf(txoutfilename,"/tmp/c%lx.%i",time(NULL),getpid());
    melpproct << "/usr/bin/melp" << "-a" << "-i" << txinfilename << "-o" << txoutfilename;
    setStatusText("encoding...");
    btnptt->setEnabled(false);
    melpproct.start();
}

void TopLevel::slotProcExitMT(KProcess *p) {
  //TX-Melpprozess fertig, Daten senden.
  int fsize;char tmp[1024];
  FILE *f;
  if ((f=fopen(txoutfilename,"r"))<0) return;
  fseek(f,0,SEEK_END);
  fsize=ftell(f);
  fseek(f,0,SEEK_SET);
  sendString("Content-Type: audio/melp\r");
  sprintf(tmp,"Size: %i\r",fsize);
  sendString(tmp);
  sendString("\r");
  while (!feof(f)) {
    fread(tmp,1,255,f);
    sendString(tmp,255);
  }
  sendString("\r");
  fclose(f);    
  remove(txinfilename);
  remove(txoutfilename);
  btnptt->setText(klocale->translate("&PTT"));
  btnptt->setEnabled(true);
  setStatusText("Ready.");
}


void TopLevel::slotProcExitMR(KProcess *p) {
    // RX-Melpprozess wurde beendet, jetzt wird der player aufgerufen.
    soxprocr.clearArguments();
    soxprocr << "/usr/bin/play"  << "-r" << "8000" << "-s" << "-w" << "-t" << "raw" << rxoutfilename;
    setStatusText("Speaking...");
    soxprocr.start();

}


void TopLevel::slotProcExitSR(KProcess *p) {
  setStatusText("Ready.");
    // RX-Soxprozess wurde beendet, jetzt sind wir fettich..
  remove(rxinfilename);
  remove(rxoutfilename);
}


void TopLevel::connectionGot( char *port, char *mycall, char *call, char *digis, int fd )
{
   if (ax25->fd != -1)
   {
      // Es besteht schon eine Verbindung. Fehlermeldung senden und
      // schliessen

      sendString( fd, "Sorry, only one connection allowed. You are number 2.\r" );


      ::close(fd);
      return;
   }
//   ax25 = new AX25();
   ax25->connectionGot( fd );

   // Hier kann irgend ein Connecttext oder aehnliches ausgesendet werden
   sendString( "TalKT - Connecttext\r" );
   VoAXState=VST_INIT_SENT;
   size=0;
   setStatusText("Incoming call.");
}



//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////


void init_globals()
{
   KConfig *kconfig;

   char *tmp;



   config = (s_config *) malloc(sizeof(s_config));

   config->maindir = (char *) malloc( strlen(getenv("HOME"))+50 );
   sprintf(config->maindir,"%s/.kde/share/apps/talkt",getenv("HOME"));
   mkdir(config->maindir, 448);


   // Konfigurations-File holen
   kconfig = mykapp->getConfig();


   kconfig->setGroup( "main" );

   if ((tmp = kconfig->readEntry("mycall").data()) != NULL)
      strcpy(config->mycall, tmp);
   else
      config->mycall[0] = '\0';

   if ((tmp = kconfig->readEntry("port").data()) != NULL)
      strcpy(config->myport, tmp);
   else
      config->myport[0] = '\0';

   if ((tmp = kconfig->readEntry("description").data()) != NULL)
      strcpy(config->description, tmp);
   else
      config->description[0] = '\0';
}


int main (int argc, char **argv)
{
   mykapp = new KApplication (argc, argv, "talkt");

   init_globals();

   toplevel = new TopLevel ();
   toplevel->show ();

   mykapp->setMainWidget(toplevel);
   return mykapp->exec ();
}


#include "main.moc"

