/*
 *  TalKT
 *  Copyright (C) 1999 Jochen Sarrazin, DG6VJ. All rights reserved.
 *  
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#ifndef MAIN_H
#define MAIN_H


#include <kapp.h>
#include <ktopwidget.h>
#include <knewpanner.h>
#include <kmenubar.h>
#include <ktoolbar.h>
#include <kstatusbar.h>
#include <kprocess.h>

#include <qpopupmenu.h>
#include <qlist.h>
#include <qheader.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qsocketnotifier.h>

#include <unistd.h>
#include <limits.h>
#include "global.h"
#include "ax25k.h"


extern QColor colors[17];

#define COLOR_BLACK 0
#define COLOR_WHITE 1
#define COLOR_DARKGRAY 2
#define COLOR_GRAY 3
#define COLOR_LIGHTGRAY 4
#define COLOR_RED 5
#define COLOR_GREEN 6
#define COLOR_BLUE 7
#define COLOR_CYAN 8
#define COLOR_MAGENTA 9
#define COLOR_YELLOW 10
#define COLOR_DARKRED 11
#define COLOR_DARKGREEN 12
#define COLOR_DARKBLUE 13
#define COLOR_DARKCYAN 14
#define COLOR_DARKMAGENTA 15
#define COLOR_DARKYELLOW 16


#define ID_STATUS 1

#define VST_INIT_SENT 0
#define VST_REC_HEADER 1
#define VST_REC_DATA 2


class TopLevel : public KTopLevelWidget
{
   Q_OBJECT;
public:
   TopLevel( const char *name=0 );
   ~TopLevel();

   void workWithFrame( char *str, int len );
   void makeAX25Connect( char *call, char *path, char *port, char *mycall );
   void setStatus( int axstate );
   void setStatusText( char *text );
   void connectionGot( char *port, char *mycall, char *call, char *digis, int fd );


   void sendString( char *str, int len );
   void sendString( char *str );
   void sendString( int fd, char *str );

   void resizeEvent(QResizeEvent *e);

public slots:
   void slotBeenden();
   void slotDisconnect();
   void slotConnect();
   void slotPrefs();
   void slotPTT();
   void slotProcExitMR(KProcess *p);
   void slotProcExitSR(KProcess *p);
   void slotProcExitMT(KProcess *p);
   void slotProcExitST(KProcess *p);

private:
   AX25 *ax25;
   ListenAX25 *listenax25;
   
   char txinfilename[PATH_MAX],txoutfilename[PATH_MAX],rxinfilename[PATH_MAX],rxoutfilename[PATH_MAX];

/*   QPopupMenu *file, *help, *pref;
   KMenuBar *menubar;*/
   KStatusBar *statusbar;

   int old_status;
   char *savestr;
   int savestrlen;
   int delspaces;
   int VoAXState;
   FILE * rxfile;
   int rxbytes,size;
   KProcess  melpprocr,soxprocr,melpproct,soxproct;

   void setupMenuBar();
   void setupToolBar();
   void setupStatusBar();

   QLabel *lcall, *lname;
   QPushButton *btnconnect, *btnptt, *btnprefs;

protected:
   void closeEvent(QCloseEvent *e);
};


void init_globals();


#endif /* MAIN_H */

